<?php
/**
 * @version $Id: rssnevobo.php  2008-03-04 22:47 
 * @package     Joomla
 * @subpackage	Content
 * @copyright	Copyright (C) 2005 - 2007 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See COPYRIGHT.php for copyright notices and details.

 * 0.2   changed heading 
 * 0.3 	 added programma function
 * 0.4.2 added filtering and points
 * 0.4.3 Het tonen van de stand van een poule incl. set en punten saldo
 *       Het tonen van het programma van een poule met de mogelijkheid om te filteren op een teamnaam
 *       Het tonen van de uitslagen van een poule met de mogelijkheid om te filteren op een teamnaam
 *       kleine layout aanpassingen
 * 0.4.4 wedstrijd in een kolom, en mogelijkheid om wedstrijdnummer niet te tonen, max aantal te tonen wedstrijden instelbaar
 * 0.5   geschikt gemaakt voor joomla 1.6
 * 0.5.1 Met dank aan Fred Peek aangepast aan de nieuwe Nevobo site
 * 0.5.2 sortering feeds aangepast
 * 0.5.3 styling
 * 0.5.4 datum uniform gemaakt, regular expressions toegepast. Wedstrijd nr verwijderd.
 * 0.5.5 uitbreiding styling, gebruik styling op basis van parameter instelling
 * 0.6.0 switchen van simplepie naar simplexml parser, waardoor quote's ook goed worden geparsed. &amp; wordt nu ook geaccepteerd in link
 * 0.6.1 aanpassing ivm lege programma's
 * 0.6.2 kleine aanpassing _callback functie
 * 0.7.0 aangepast om te kunnen werken met de JSON API van volleybal.nl
 * 0.7.1 bugfix ivm met de mogelijkheid van meedere poules per team
*/

/*
nieuwe links

http://api.volleybal.nl/search/organisations/voltena

http://api.volleybal.nl/search/teams/voltena

http://api.volleybal.nl/ranking/1230MB%204   stand

http://api.volleybal.nl/results/team/1230MB%204 uitslagen

http://api.volleybal.nl/matches/team/1230MB%204  programma

http://api.volleybal.nl/matches/organisation/1230  programma vereniging

oude links werken blijkbaar ook nog, maar niet meer in deze versie van de plugin
https://api.nevobo.nl/export/team/CKL5T1J/meisjes-b/4/programma.rss
https://api.nevobo.nl/export/poule/regio-noord/MB1G/programma.rss

https://api.nevobo.nl/export/team/CKL5T1J/meisjes-b/4/resultaten.rss
https://api.nevobo.nl/export/poule/regio-noord/MB1G/resultaten.rss

https://api.nevobo.nl/export/poule/regio-noord/MB1G/stand.rss


*/

defined( '_JEXEC' ) or die();

jimport('joomla.plugin.plugin');


class plgContentrssnevobo extends JPlugin
{
	/**
	 * @param	string	The context of the content being passed to the plugin.
	 * @param	object	The article object.  Note $article->text is also available
	 * @param	object	The article params
	 * @param	int		The 'page' number
	 */
	public function onContentPrepare($context, &$article, &$params, $page = 0)
	{
		// Simple performance check to determine whether bot should process further.
		if (JString::strpos($article->text, 'rssnevobo') === false) {
			return true;
		}
		$document = JFactory::getDocument();
		$mystyle = $this->params->get('stijl', '');
		$document->addStyleSheet(JURI::root().'plugins/content/rssnevobo/rssnevobo-'.$mystyle.'.css');		
		
		// Define the regular expression for the bot.
		$regex = "#{rssnevobo*(.*?)}(.*?){/rssnevobo}#s";
		
		// Perform the replacement.
		$article->text = preg_replace_callback($regex, array(&$this, '_replace'), $article->text);

		return true;
	}
	
	
	protected function _replace(&$matches)
	{
// 		voor debugging
//		ini_set('display_errors', 'On');
//		error_reporting(E_ALL | E_STRICT);

		jimport('joomla.utilities.utility');

		$args = JUtility::parseAttributes($matches[1]);
		$json_url = strip_tags(trim($matches[2]));
		if (get_magic_quotes_gpc())
		{
			$json_url = stripslashes($json_url);
		}

		$rsscache = (int)JArrayHelper::getValue($args, 'cache', '10');
		$rssfilter = JArrayHelper::getValue($args, 'filter','');

		$rssaantal = (int)JArrayHelper::getValue($args,'aantal',999);
		$rsstype = (int)JArrayHelper::getValue($args,'type',0); // type: 0=stand; 1=programma; 2=uitslagen
		$poulenr = (int)JArrayHelper::getValue($args,'poulenr',1);
		$rssitems 			= 999;
		$content_buffer     = '';
		$params0 = '';
		$numstr = '';
		$dummy = "Nog geen programma bekend";		
		if ($json_url != "") { 			// only if array element is not empty

			$json = str_replace('&amp;', "&",$json_url);   //robuster gemaakt, editor vervangt & namelijk steeds door &amp; op de achtergrond
			
			// get json object
			
			$json_file = file_get_contents($json);
			$json_obj = json_decode ($json_file);
			
			// mogelijk nog wat robuuster
			
    		$content_buffer .= '<div style="direction: ' . 'ltr; ' . 'text-align: '. 'left;' .'">';
			
			$json_status = (string) $json_obj->{'status'};
						
			if ($json_status == 'success')  {
				
				if ($rsstype == 1) {		// programma
				
					$content_buffer .= '<table id="nevobotable">';			
					$content_buffer .= '<thead><tr><th class="topleft">Datum</th><th>Tijd</th><th>Thuis</th><th>Uit</th><th class="topright">Sporthal</th></tr></thead><tbody>';	
					
					foreach ($json_obj->{'data'} as $mydata) {						
						if ($rssaantal == 0) break; 							
						if (gettype($mydata) != 'string') {
							if (($this->_checkfilter($rssfilter, $mydata->{'home'}->{'name'}) !== false) || ($this->_checkfilter($rssfilter, $mydata->{'away'}->{'name'}) !== false)) {
								$rssaantal = $rssaantal - 1;
								$content_buffer .= '<tr ' .$this->_isodd($rssaantal). '><td>' .  $mydata->{'description'}  . '</td><td>'. $mydata->{'time'} . '</td><td>'. $mydata->{'home'}->{'name'} . '</td><td>' . $mydata->{'away'}->{'name'} .  '</td><td>'. $mydata->{'location'} .'</td></tr>';			
							}
						}	
					}
					$content_buffer .= '<tfoot><tr><td class="botleft"></td><td></td><td></td><td></td><td class="botright"></td></tr></tfoot>';	
					$content_buffer .= '</table>';
					
					
				} else if ($rsstype == 0) {		// stand
							
					$content_buffer .= '<table id="nevobotable">';			
					$content_buffer .= '<thead><tr><th class="topleft">Nr.</th><th>Team</th><th>Wedstrijden</th><th>Punten</th><th>Sets voor</th><th class="topright">Sets tegen</th></tr></thead><tbody>';	
					$thispoule = 1;
					foreach ($json_obj->{'data'} as $mydata) {   // voor alle poules 
						if ($thispoule == $poulenr) { 
							foreach ($mydata->{'poule'} as $mymatches) { 
								$rssaantal = $rssaantal - 1;
								$content_buffer .= '<tr '.$this->_isodd($rssaantal).' ><td>' .  $mymatches->{'position'}  . '</td><td>' .  $mymatches->{'name'}  . '</td><td>'. $mymatches->{'games'} . '</td><td>'. $mymatches->{'points'} . '</td><td>' . $mymatches->{'setWins'} .  '</td><td>'. $mymatches->{'setLosses'} .'</td></tr>';			
							}
						}
						$thispoule = $thispoule + 1;
					}
					$content_buffer .= '<tfoot><tr><td class="botleft"></td><td></td><td></td><td></td><td></td><td class="botright"></td></tr></tfoot>';	
					$content_buffer .= '</table>';
				} else if ($rsstype == 2) {		// uitslagen
				
					$content_buffer .= '<table id="nevobotable">';			
							$content_buffer .= '<thead><tr><th class="topleft">Datum</th><th>Thuis</th><th>Uit</th><th class="topright">Uitslag</th></tr></thead><tbody>';	
					
					foreach ($json_obj->{'data'} as $mydata) {
						
						if ($rssaantal == 0) break; 							
						if (gettype($mydata) != 'string') {
							if (($this->_checkfilter($rssfilter, $mydata->{'home'}->{'name'}) !== false) || ($this->_checkfilter($rssfilter, $mydata->{'away'}->{'name'}) !== false)) {								
								$rssaantal = $rssaantal - 1;		
								$content_buffer .= '<tr '.$this->_isodd($rssaantal).' ><td>' .  $mydata->{'description'}  . '</td><td>'. $mydata->{'home'}->{'name'} . '</td><td>' . $mydata->{'away'}->{'name'} .  '</td><td>'. $mydata->{'score'} .'</td></tr>';
							}
						}	
					}
					$content_buffer .= '<tfoot><tr><td class="botleft"></td><td></td><td></td><td class="botright"></td></tr></tfoot>';	
					$content_buffer .= '</table>';	
				}
			}
		}
		$content_buffer .= '</div>';
		return $content_buffer;
	}

	// om de style voor de oneven regels te manipuleren
	
	function _isodd ($nr) {
		$text = ''; 
		if (1 & $nr) { $text = 'class ="odd"'; } 
		return $text;
	}
	
	// check of een substring voorkomt. 
	
	function _checkfilter ($f, $t) { 				
		if ($f != '') {
			$pos = stripos ($t, $f);
		} else {
			$pos = true;	
		}
		return $pos;
	}
	

} // End Class